From d5cb8ea52e69297a88977bfe83e9dfe0631ece24 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 27 2021 19:31:27 +0000
Subject: [PATCH 2071/2232] Merge pull request #694 from dtolnay/sendstring


Allow Send/Sync of let_cxx_string
---

diff --git a/src/cxx_string.rs b/src/cxx_string.rs
index 10abbce..08a58b1 100644
--- a/src/cxx_string.rs
+++ b/src/cxx_string.rs
@@ -188,7 +188,7 @@ impl PartialEq<str> for CxxString {
 pub struct StackString {
     // Static assertions in cxx.cc validate that this is large enough and
     // aligned enough.
-    space: MaybeUninit<[*const (); 8]>,
+    space: MaybeUninit<[usize; 8]>,
 }
 
 impl StackString {
diff --git a/tests/cxx_string.rs b/tests/cxx_string.rs
new file mode 100644
index 0000000..be693cd
--- /dev/null
+++ b/tests/cxx_string.rs
@@ -0,0 +1,15 @@
+use cxx::{let_cxx_string, CxxString};
+
+#[test]
+fn test_async_cxx_string() {
+    async fn f() {
+        let_cxx_string!(s = "...");
+
+        async fn g(_: &CxxString) {}
+        g(&s).await;
+    }
+
+    // https://github.com/dtolnay/cxx/issues/693
+    fn assert_send(_: impl Send) {}
+    assert_send(f());
+}

